# all files / ol/ featureloader.js

74.58% Statements 44/59
42.31% Branches 11/26
87.5% Functions 7/8
74.58% Lines 44/59

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    1831×
    1×
    1×

    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×
    4×

    4×
    4×

    4×

    4×
    4×

    4×
    4×

    4×
    4×
    4×

    4×
    4×
    1×
    1×

    4×

    4×

    4×
    2×

    2×

    1×
    1×

    1×

    1×
    3×

    3×

     goog.provide('ol.FeatureLoader');
    goog.provide('ol.FeatureUrlFunction');
    goog.provide('ol.featureloader');

    goog.require('goog.asserts');
    goog.require('goog.events');
    goog.require('goog.net.EventType');
    goog.require('goog.net.XhrIo');
    goog.require('goog.net.XhrIo.ResponseType');
    goog.require('ol.TileState');
    goog.require('ol.VectorTile');
    goog.require('ol.format.FormatType');
    goog.require('ol.proj');
    goog.require('ol.proj.Projection');
    goog.require('ol.proj.Units');
    goog.require('ol.xml');

    /**
     * {@link ol.source.Vector} sources use a function of this type to load
     * features.
     *
     * This function takes an {@link ol.Extent} representing the area to be loaded,
     * a `{number}` representing the resolution (map units per pixel) and an
     * {@link ol.proj.Projection} for the projection  as arguments. `this` within
     * the function is bound to the {@link ol.source.Vector} it's called from.
     *
     * The function is responsible for loading the features and adding them to the
     * source.
     * @api
     * @typedef {function(this:ol.source.Vector, ol.Extent, number,
     *                    ol.proj.Projection)}
     */
    ol.FeatureLoader;

    /**
     * {@link ol.source.Vector} sources use a function of this type to get the url
     * to load features from.
     *
     * This function takes an {@link ol.Extent} representing the area to be loaded,
     * a `{number}` representing the resolution (map units per pixel) and an
     * {@link ol.proj.Projection} for the projection  as arguments and returns a
     * `{string}` representing the URL.
     * @api
     * @typedef {function(ol.Extent, number, ol.proj.Projection) : string}
     */
    ol.FeatureUrlFunction;

    /**
     * @param {string|ol.FeatureUrlFunction} url Feature URL service.
     * @param {ol.format.Feature} format Feature format.
     * @param {function(this:ol.VectorTile, Array.<ol.Feature>, ol.proj.Projection)|function(this:ol.source.Vector, Array.<ol.Feature>)} success
     *     Function called with the loaded features and optionally with the data
     *     projection. Called with the vector tile or source as `this`.
     * @param {function(this:ol.VectorTile)|function(this:ol.source.Vector)} failure
     *     Function called when loading failed. Called with the vector tile or
     *     source as `this`.
     * @return {ol.FeatureLoader} The feature loader.
     */
    ol.featureloader.loadFeaturesXhr = function(url, format, success, failure) {
      return (
          /**
           * @param {ol.Extent} extent Extent.
           * @param {number} resolution Resolution.
           * @param {ol.proj.Projection} projection Projection.
           * @this {ol.source.Vector|ol.VectorTile}
           */
          function(extent, resolution, projection) {
            var xhrIo = new goog.net.XhrIo();
            xhrIo.setResponseType(
                format.getType() == ol.format.FormatType.ARRAY_BUFFER ?
                    goog.net.XhrIo.ResponseType.ARRAY_BUFFER :
                    goog.net.XhrIo.ResponseType.TEXT);
            goog.events.listen(xhrIo, goog.net.EventType.COMPLETE,
                /**
                 * @param {Event} event Event.
                 * @private
                 * @this {ol.source.Vector}
                 */
                function(event) {
                  var xhrIo = event.target;
                  goog.asserts.assertInstanceof(xhrIo, goog.net.XhrIo,
                      'event.target/xhrIo is an instance of goog.net.XhrIo');
                  Eif (xhrIo.isSuccess()) {
                    var type = format.getType();
                    /** @type {Document|Node|Object|string|undefined} */
                    var source;
                    Eif (type == ol.format.FormatType.JSON) {
                      source = xhrIo.getResponseText();
                    } else if (type == ol.format.FormatType.TEXT) {
                      source = xhrIo.getResponseText();
                    } else if (type == ol.format.FormatType.XML) {
                      if (!goog.userAgent.IE) {
                        source = xhrIo.getResponseXml();
                      }
                      if (!source) {
                        source = ol.xml.parse(xhrIo.getResponseText());
                      }
                    } else if (type == ol.format.FormatType.ARRAY_BUFFER) {
                      source = xhrIo.getResponse();
                    } else {
                      goog.asserts.fail('unexpected format type');
                    }
                    Eif (source) {
                      if (ol.ENABLE_VECTOR_TILE && this instanceof ol.VectorTile) {
                        var dataUnits = format.readProjection(source).getUnits();
                        Iif (dataUnits === ol.proj.Units.TILE_PIXELS) {
                          projection = new ol.proj.Projection({
                            code: this.getProjection().getCode(),
                            units: dataUnits
                          });
                          this.setProjection(projection);
                        }
                      }
                      success.call(this, format.readFeatures(source,
                          {featureProjection: projection}));
                    } else {
                      goog.asserts.fail('undefined or null source');
                    }
                  } else {
                    failure.call(this);
                  }
                  goog.dispose(xhrIo);
                }, false, this);
            if (goog.isFunction(url)) {
              xhrIo.send(url(extent, resolution, projection));
            } else {
              xhrIo.send(url);
            }

          });
    };

    /**
     * Create an XHR feature loader for a `url` and `format`. The feature loader
     * loads features (with XHR), parses the features, and adds them to the
     * vector tile.
     * @param {string|ol.FeatureUrlFunction} url Feature URL service.
     * @param {ol.format.Feature} format Feature format.
     * @return {ol.FeatureLoader} The feature loader.
     * @api
     */
    ol.featureloader.tile = function(url, format) {
      return ol.featureloader.loadFeaturesXhr(url, format,
          /**
           * @param {Array.<ol.Feature>} features The loaded features.
           * @this {ol.VectorTile}
           */
          function(features) {
            this.setFeatures(features);
          },
          /**
           * @this {ol.VectorTile}
           */
          function() {
            this.setState(ol.TileState.ERROR);
          });
    };

    /**
     * Create an XHR feature loader for a `url` and `format`. The feature loader
     * loads features (with XHR), parses the features, and adds them to the
     * vector source.
     * @param {string|ol.FeatureUrlFunction} url Feature URL service.
     * @param {ol.format.Feature} format Feature format.
     * @return {ol.FeatureLoader} The feature loader.
     * @api
     */
    ol.featureloader.xhr = function(url, format) {
      return ol.featureloader.loadFeaturesXhr(url, format,
          /**
           * @param {Array.<ol.Feature>} features The loaded features.
           * @this {ol.source.Vector}
           */
          function(features) {
            this.addFeatures(features);
          }, /* FIXME handle error */ ol.nullFunction);
    };